<?php

/**
 * Implementation of hook_admin_settings().
 */
function absolute_messages_admin_settings_form(&$form_state) {
  $form = array();
  
  $form['general'] = array(
    '#type'         => 'fieldset',
    '#title'        => t('General settings'),
  );
  $form['general']['absolute_messages_dismiss_all_count'] = array(
    '#type'           => 'textfield',
    '#title'          => t('Show "Dismiss all messages" when number of messages is higher than'),
    '#default_value'  => variable_get('absolute_messages_dismiss_all_count', 3),
  );
  $form['general']['absolute_messages_display_lines'] = array(
    '#type'           => 'textfield',
    '#title'          => t('Maximum number of message lines to display'),
    '#description'    => t('If set, only first n lines of each message will be displayed, expanding to full message after clicking on it. Useful for length messages. Leave empty for no limit.'),
    '#default_value'  => variable_get('absolute_messages_display_lines', ''),
  );
  
  $form['autodismiss'] = array(
    '#type'         => 'fieldset',
    '#title'        => t('Automatically dismiss messages'),
    '#description'  => t('Automatically dismiss all/some messages after specific time.'),
  );
  foreach (_absolute_messages_message_types() as $message_type) {
    $form['autodismiss']['absolute_messages_dismiss_' . $message_type] = array(
      '#type'           => 'checkbox',
      '#title'          => t('Automatically dismiss %type messages', array('%type' => $message_type)),
      '#default_value'  => variable_get('absolute_messages_dismiss_' . $message_type, FALSE),
    );
    $form['autodismiss']['absolute_messages_dismiss_time_' . $message_type] = array(
      '#type'           => 'textfield',
      '#title'          => t('Automatically dismiss %type messages after', array('%type' => $message_type)),
      '#default_value'  => variable_get('absolute_messages_dismiss_time_' . $message_type, ''),
      '#field_suffix'   => t('seconds'),
    );
  }
  
  return system_settings_form($form);
}
